/*
   KQ is Copyright (C) 2002 - Josh Bolduc

   This file is part of KQ... a freeware RPG.

   KQ is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published
   by the Free Software Foundation; either version 2, or (at your
   option) any later version.

   KQ is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with KQ; see the file COPYING.  If not, write to
   the Free Software Foundation,
       675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*! \file
 * \brief Defines for all items
 * \author JB
 * \date ??????
 */

#ifndef __ITEMDEFS_H
#define __ITEMDEFS_H

/* The description for these items are in src\res.c */

#define I_NOITEM            0    /* Emtpy */
#define I_MACE1             1    /* Mace */
#define I_MACE2             2    /* Morningstar */
#define I_MACE3             3    /* Frozen Star */
#define I_MACE4             4    /* Death's Head */
#define I_HAMMER1           5    /* War Hammer */
#define I_HAMMER2           6    /* Stun Hammer */
#define I_HAMMER3           7    /* Battle Hammer */
#define I_HAMMER4           8    /* Thor's Hammer */
#define I_SWORD1            9    /* Rapier */
#define I_SWORD2            10   /* Short Sword */
#define I_SWORD3            11   /* Long Sword */
#define I_SWORD4            12   /* Katana */
#define I_SWORD5            13   /* Great Sword */
#define I_SWORD6            14   /* Dragon Sword */
#define I_SWORD7            15   /* Avenger Blade */
#define I_AXE1              16   /* Hand Axe */
#define I_AXE2              17   /* Battle Axe */
#define I_AXE3              18   /* Hunter's Axe */
#define I_AXE4              19   /* Slayer's Axe */
#define I_KNIFE1            20   /* Knife */
#define I_KNIFE2            21   /* Long Knife */
#define I_KNIFE3            22   /* Balmar's Dagger */
#define I_KNIFE4            23   /* Aichasi Knife */
#define I_SPEAR1            24   /* Half Spear */
#define I_SPEAR2            25   /* Long Spear */
#define I_SPEAR3            26   /* Battle Spear */
#define I_SPEAR4            27   /* Chaku Spear */
#define I_ROD1              28   /* Iron Rod */
#define I_ROD2              29   /* Rod of Fire */
#define I_ROD3              30   /* Gloom Rod */
#define I_ROD4              31   /* Crystal Rod */
#define I_ROD5              32   /* Temmet Rod */
#define I_STAFF1            33   /* Staff */
#define I_STAFF2            34   /* Soul Staff */
#define I_STAFF3            35   /* Defender Staff */
#define I_STAFF4            36   /* Pentha Staff */
#define I_STAFF5            37   /* Maham Staff */
#define I_SHIELD1           38   /* Wooden Shield */
#define I_SHIELD2           39   /* Iron Shield */
#define I_SHIELD3           40   /* Steel Shield */
#define I_SHIELD4           41   /* Tegal Buckler */
#define I_SHIELD5           42   /* Aegis Shield */
#define I_SHIELD6           43   /* Opal Shield */
#define I_SHIELD7           44   /* Unadium Shield */
#define I_CAP1              45   /* Cap */
#define I_CAP2              46   /* Wizard Cap */
#define I_CAP3              47   /* Bandanna */
#define I_CAP4              48   /* Ribbon of Ayol */
#define I_CAP5              49   /* Mask of Tyras */
#define I_HELM1             50   /* Leather Helm */
#define I_HELM2             51   /* Iron Helm */
#define I_HELM3             52   /* Steel Helm */
#define I_HELM4             53   /* Opal Helm */
#define I_HELM5             54   /* Unadium Helm */
#define I_ROBE1             55   /* Cloth Robe */
#define I_ROBE2             56   /* Wizard's Robe */
#define I_ROBE3             57   /* Sorceror Robe */
#define I_ROBE4             58   /* Arch-Magi Robe */
#define I_ROBE5             59   /* Trenta Robes */
#define I_SUIT1             60   /* Garment */
#define I_SUIT2             61   /* Fighting Suit */
#define I_SUIT3             62   /* Battle Suit */
#define I_SUIT4             63   /* Flanel Shirt */
#define I_SUIT5             64   /* Power Suit */
#define I_ARMOR1            65   /* Leather Armor */
#define I_ARMOR2            66   /* Bronze Armor */
#define I_ARMOR3            67   /* Chain Mail */
#define I_ARMOR4            68   /* Gold Armor */
#define I_ARMOR5            69   /* Plate Mail */
#define I_ARMOR6            70   /* Dragon Armor */
#define I_ARMOR7            71   /* Opal Armor */
#define I_ARMOR8            72   /* Crystal Armor */
#define I_ARMOR9            73   /* Unadium Armor */
#define I_BAND1             74   /* Quartz Band */
#define I_BAND2             75   /* Adamant Band */
#define I_BAND3             76   /* Opal Band */
#define I_BAND4             77   /* Unadium Band */
#define I_GLOVES1           78   /* Gloves */
#define I_GLOVES2           79   /* Ninja Gloves */
#define I_GAUNTLET1         80   /* Battle Gauntlets */
#define I_GAUNTLET2         81   /* Titan Gaunlets */
#define I_GAUNTLET3         82   /* Force Gauntlets */
#define I_SPEEDBOOTS        83   /* Boots of Speed */
#define I_HERMES            84   /* Hermes Shoes */
#define I_AGRAN             85   /* Agran Talisman */
#define I_EAGLEEYES         86   /* Eagle Eyes */
#define I_PURITYGEM         87   /* Gem of Purity */
#define I_MANALOCKET        88   /* Mana Locket */
#define I_MESRA             89   /* Mesra Feather */
#define I_OCEANPEARL        90   /* Ocean Pearl */
#define I_POWERBRACE        91   /* Power Brace */
#define I_PRIESTESS         92   /* Priestess Charm */
#define I_REGENERATOR       93   /* Regenerator */
#define I_RUBYBROOCH        94   /* Ruby Brooch */
#define I_SHADECLOAK        95   /* Cloak of Shades */
#define I_DEFCLOAK          96   /* Defense Cloak */
#define I_RUNECLOAK         97   /* Rune Cloak */
#define I_SPIRITCAPE        98   /* Spirit Cape */
#define I_WOODCLOAK         99   /* Woodland Cloak */
#define I_WATERRING         100  /* Water Ring */
#define I_PALADINRING       101  /* Paladin's Ring */
#define I_RILOCRING         102  /* Riloc's Ring */
#define I_MHERB             103  /* Medicinal Herb */
#define I_NLEAF             104  /* Neliram Leaf */
#define I_OSEED             105  /* Olginar Seed */
#define I_STRSEED           106  /* Selingas Seed */
#define I_AGISEED           107  /* Amasian Seed */
#define I_VITSEED           108  /* Vecindu Seed */
#define I_INTSEED           109  /* Ingral Seed */
#define I_WISSEED           110  /* Walsiras Seed */
#define I_EDROPS            111  /* Elimas Drops */
#define I_EDAENRA           112  /* Elixir of Daenra */
#define I_KBREW             113  /* Krendar's Brew */
#define I_LTONIC            114  /* Larinon Tonic */
#define I_NPOULTICE         115  /* Nidana Poultice */
#define I_PCURING           116  /* Potion of Curing */
#define I_SALVE             117  /* Salve */
#define I_WENSAI            118  /* Water of Ensai */
#define I_HPUP              119  /* Elixir of Health */
#define I_MPUP              120  /* Mystic Elixir */
#define I_SSTONE            121  /* Sun Stone */
#define I_RRUNE             122  /* Rune of Recovery */
#define I_WRUNE             123  /* Rune of Air */
#define I_ERUNE             124  /* Rune of Earth */
#define I_FRUNE             125  /* Rune of Fire */
#define I_IRUNE             126  /* Rune of Water */
#define I_TP100S            127  /* Thin sliver of wood */
#define I_B_CURE1           128  /* Spell Scroll: Cure1 */
#define I_B_HOLD            129  /* Spell Scroll: Hold */
#define I_B_SHIELD          130  /* Spell Scroll: Shield */
#define I_B_SILENCE         131  /* Spell Scroll: Silence */
#define I_B_SLEEP           132  /* Spell Scroll: Sleep */
#define I_B_BLESS           133  /* Spell Scroll: Bless */
#define I_B_VISION          134  /* Spell Scroll: Vision */
#define I_B_CURE2           135  /* Spell Scroll: Cure2 */
#define I_B_HOLYMIGHT       136  /* Spell Scroll: Holy Might */
#define I_B_RESTORE         137  /* Spell Scroll: Restore */
#define I_B_FADE            138  /* Spell Scroll: Fade */
#define I_B_HASTEN          139  /* Spell Scroll: Hasten */
#define I_B_LIFE            140  /* Spell Scroll: Life */
#define I_B_SHELL           141  /* Spell Scroll: Shell */
#define I_B_WHIRLWIND       142  /* Spell Scroll: Whirlwind */
#define I_B_FLOOD           143  /* Spell Scroll: Flood */
#define I_B_RECOVERY        144  /* Spell Scroll: Recovery */
#define I_B_SHIELDALL       145  /* Spell Scroll: Shield All */
#define I_B_SLEEPALL        146  /* Spell Scroll: Sleep All */
#define I_B_CURE3           147  /* Spell Scroll: Cure3 */
#define I_B_REGENERATE      148  /* Spell Scroll: Regenerate */
#define I_B_REPULSE         149  /* Spell Scroll: Repulse */
#define I_B_THROUGH         150  /* Spell Scroll: Through */
#define I_B_QUICKEN         151  /* Spell Scroll: Quicken */
#define I_B_TRUEAIM         152  /* Spell Scroll: True Aim */
#define I_B_WALL            153  /* Spell Scroll: Wall */
#define I_B_DIVINEGUARD     154  /* Spell Scroll: Divine Guard */
#define I_B_TORNADO         155  /* Spell Scroll: Tornado */
#define I_B_FULLLIFE        156  /* Spell Scroll: Full Life */
#define I_B_CURE4           157  /* Spell Scroll: Cure4 */
#define I_B_LUMINE          158  /* Spell Scroll: Lumine */
#define I_B_TSUNAMI         159  /* Spell Scroll: Tsunami */
#define I_B_VENOM           160  /* Spell Scroll: Venom */
#define I_B_SCORCH          161  /* Spell Scroll: Scorch */
#define I_B_BLIND           162  /* Spell Scroll: Blind */
#define I_B_CONFUSE         163  /* Spell Scroll: Confuse */
#define I_B_SHOCK           164  /* Spell Scroll: Shock */
#define I_B_GLOOM           165  /* Spell Scroll: Gloom */
#define I_B_NAUSEA          166  /* Spell Scroll: Nausea */
#define I_B_FROST           167  /* Spell Scroll: Frost */
#define I_B_SLOW            168  /* Spell Scroll: Slow */
#define I_B_DRAIN           169  /* Spell Scroll: Drain */
#define I_B_FIREBLAST       170  /* Spell Scroll: Fire Blast */
#define I_B_WARP            171  /* Spell Scroll: Warp */
#define I_B_STONE           172  /* Spell Scroll: Stone */
#define I_B_LIGHTNING       173  /* Spell Scroll: Lightning */
#define I_B_VIRUS           174  /* Spell Scroll: Virus */
#define I_B_TREMOR          175  /* Spell Scroll: Tremor */
#define I_B_ABSORB          176  /* Spell Scroll: Absorb */
#define I_B_DIFFUSE         177  /* Spell Scroll: Diffuse */
#define I_B_DOOM            178  /* Spell Scroll: Doom */
#define I_B_MALISON         179  /* Spell Scroll: Malison */
#define I_B_FLAMEWALL       180  /* Spell Scroll: Flame Wall */
#define I_B_BLIZZARD        181  /* Spell Scroll: Blizzard */
#define I_B_DEATH           182  /* Spell Scroll: Death */
#define I_B_THUNDERSTORM    183  /* Spell Scroll: Thunder Storm */
#define I_B_NEGATIS         184  /* Spell Scroll: Negatis */
#define I_B_EARTHQUAKE      185  /* Spell Scroll: Earthquake */
#define I_B_PLAGUE          186  /* Spell Scroll: Plague */
#define I_B_XSURGE          187  /* Spell Scroll: X-Surge */
#define I_CHENDIGAL         188  /* Chendigal */
#define I_CHENDIGRA         189  /* Chendigra */
#define I_DYNAMITE          190  /* Dynamite */


#endif /*  __ITEMDEFS_H  */
